
uniform mat4 u_m44ModelViewProjection;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec3 a_v3Normal;

varying mediump vec2 v_v2TexCoord;
varying mediump vec3 v_v3Reflection;

uniform mediump vec3 u_v3EyePosition;

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	
	mediump vec3 v3Incident = a_v4Position.xyz - u_v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, a_v3Normal) * a_v3Normal / dot(a_v3Normal, a_v3Normal);	
	v3Reflection.xz = -v3Reflection.zx;
	
	v_v3Reflection = v3Reflection;
	
	
}

