
precision lowp float;

uniform lowp sampler2D tex;
uniform lowp samplerCube texCubeMap;
uniform lowp sampler2D texSpecular;

varying mediump vec2 v_v2TexCoord;
varying mediump vec3 v_v3Reflection;

uniform lowp float u_fRewindEffect;
uniform lowp float u_fBrightness;


void main() 
{
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord);
	lowp float fSpecular = texture2D(texSpecular, v_v2TexCoord).r;	
	
	lowp vec4 v4TextureCube = textureCube(texCubeMap, v_v3Reflection);
		
	gl_FragColor = (v4Texture + v4TextureCube * fSpecular) * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;	
}
