
precision lowp float;

uniform lowp sampler2D tex;
uniform lowp samplerCube texCubeMap;
uniform lowp sampler2D texSpecular;

varying mediump vec2 v_v2TexCoord;
varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;

uniform mediump vec3 u_v3EyePosition;
uniform lowp float u_fRewindEffect;
uniform lowp float u_fBrightness;

void main() 
{
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord);
	lowp float fSpecular = texture2D(texSpecular, v_v2TexCoord).r;
	
	mediump vec3 v3Incident = v_v3WorldPosition - u_v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v_v3Normal) * v_v3Normal / dot(v_v3Normal, v_v3Normal);	
	v3Reflection.xz = -v3Reflection.zx;
	lowp vec4 v4TextureCube = textureCube(texCubeMap, v3Reflection);
	
	lowp vec4 v4Tmp1 = (v4Texture + v4TextureCube * fSpecular) * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;	
		
	lowp vec4 v4Tmp2 = 1.0 - v4Tmp1;
	gl_FragColor = v4Tmp1 * (2.0 - u_fBrightness) + (1.0 - v4Tmp2 * v4Tmp2 * v4Tmp2) * (u_fBrightness - 1.0);	
}
