

uniform mat4 u_m44ModelViewProjection;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec4 a_v4Color;

varying highp vec2 v_v2TexCoord;
varying lowp vec4 v_v4Color;
varying mediump float v_fAlphaVFade;
uniform float u_fTop;
uniform float u_fBottom;



void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v4Color = a_v4Color * (1.0 / 255.0);
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	float fClamp = (a_v4Position.y - u_fTop) * 0.02;
	float fClampB = (a_v4Position.y - u_fBottom) * -0.02;
	if (fClamp > fClampB)
		fClamp = fClampB;	
	v_fAlphaVFade = fClamp;
}

